// uninstall.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <bzswin/bzsdev.h>
#include <bzswin/registry.h>
#include <bzscmn/file.h>

#pragma comment(lib, "setupapi")

using namespace BazisLib;

bool IsDiskEnumeratorInstalled(LPCTSTR lpHwID)
{
	DeviceInformationSet devs = DeviceInformationSet::GetLocalDevices();
	for (DeviceInformationSet::iterator it = devs.begin(); it != devs.end(); it++)
	{
		if (!it.GetDeviceRegistryProperty(SPDRP_HARDWAREID).compare(lpHwID))
			return true;
	}
	return false;
}

void RemoveDiskEnumerator(LPCTSTR lpHwID)
{
	DeviceInformationSet devs = DeviceInformationSet::GetLocalDevices();
	for (DeviceInformationSet::iterator it = devs.begin(); it != devs.end(); it++)
	{
		if (!it.GetDeviceRegistryProperty(SPDRP_HARDWAREID).compare(lpHwID))
			it.CallClassInstaller(DIF_REMOVE);
	}
}

void RemoveRegistryKeys()
{
	RegistryKey key(HKEY_CLASSES_ROOT, _T("Applications"));
	key.DeleteSubKeyRecursive(_T("vmnt.exe"));
	key.DeleteSubKeyRecursive(_T("vmnt64.exe"));
/*	RegistryKey key2(HKEY_CLASSES_ROOT, _T(""));
	key2.DeleteSubKeyRecursive(_T("BazisVirtualCD.Iso"));
	key2.DeleteSubKeyRecursive(_T("BazisVirtualCD.Cue"));
	key2.DeleteSubKeyRecursive(_T("BazisVirtualCD.Img"));*/
	RegistryKey key3(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall"));
	key3.DeleteSubKeyRecursive(_T("WinCDEmu"));
}

void RemoveTreeRecursive(LPCTSTR pTreePath)
{
	TCHAR tszMask[MAX_PATH];
	int pos = _sntprintf(tszMask, sizeof(tszMask)/sizeof(tszMask[0]), _T("%s\\*.*"), pTreePath) - 3;
	WIN32_FIND_DATA WFD;
	HANDLE hFind = FindFirstFile(tszMask, &WFD);
	if ((hFind == INVALID_HANDLE_VALUE) || !hFind)
		return;
	do
	{
		if ((WFD.cFileName[0] == '.') && ((WFD.cFileName[1] == '.') || (WFD.cFileName[1] == 0)))
			continue;
		_tcsncpy(&tszMask[pos], WFD.cFileName, sizeof(tszMask)/sizeof(tszMask[0]) - pos);
		if (WFD.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			RemoveTreeRecursive(tszMask);
		if (!DeleteFile(tszMask))
			MoveFileEx(tszMask, NULL, MOVEFILE_DELAY_UNTIL_REBOOT);
	} while (FindNextFile(hFind, &WFD));
	FindClose(hFind);
	if (!RemoveDirectory(pTreePath))
		MoveFileEx(pTreePath, NULL, MOVEFILE_DELAY_UNTIL_REBOOT);
}

void DeleteFiles()
{
	TCHAR tsz[MAX_PATH] = {0,};
	GetModuleFileName(GetModuleHandle(NULL), tsz, sizeof(tsz)/sizeof(tsz[0]));
	TCHAR *p = _tcsrchr(tsz, '\\');
	if (!p)
		return;
	p[0] = 0;
	FilePath path(tsz);
	RemoveTreeRecursive((path + FilePath(_T("x86"))).c_str());
	RemoveTreeRecursive((path + FilePath(_T("x64"))).c_str());
	RemoveTreeRecursive((path + FilePath(_T("langfiles"))).c_str());
	File::Delete(path + FilePath(_T("vmnt.exe")));
	File::Delete(path + FilePath(_T("vmnt64.exe")));
	File::Delete(path + FilePath(_T("batchmnt.exe")));
	File::Delete(path + FilePath(_T("batchmnt64.exe")));
	File::Delete(path + FilePath(_T("BazisVirtualCD.inf")));
	File::Delete(path + FilePath(_T("VirtDiskBus.inf")));
	File::Delete(path + FilePath(_T("BazisVirtualCDBus.inf")));
	File::Delete(path + FilePath(_T("BazisVirtualCD.cat")));
	File::Delete(path + FilePath(_T("VirtDiskBus.cat")));
	File::Delete(path + FilePath(_T("BazisVirtualCDBus.cat")));
	p[0] = '\\';
	MoveFileEx(tsz, NULL, MOVEFILE_DELAY_UNTIL_REBOOT);
	MoveFileEx(path.c_str(), NULL, MOVEFILE_DELAY_UNTIL_REBOOT);
}

#pragma comment(lib, "ntdll")

int WINAPI CALLBACK WinMain (
		 __in HINSTANCE hInstance,
		 __in_opt HINSTANCE hPrevInstance,
		 __in_opt LPSTR lpCmdLine,
		 __in int nShowCmd
		 )
{
	if (strstr(lpCmdLine, "/CLEANUP2X"))
	{
		RemoveDiskEnumerator(_T("root\\bzsvdisk"));

		TCHAR tsz[MAX_PATH] = {0,};
		GetModuleFileName(GetModuleHandle(NULL), tsz, sizeof(tsz)/sizeof(tsz[0]));
		TCHAR *p = _tcsrchr(tsz, '\\');
		if (!p)
			return 0;
		p[0] = 0;
		FilePath path(tsz);
		File::Delete(path + FilePath(_T("BazisVirtualCD.inf")));
		File::Delete(path + FilePath(_T("BazisVirtualCD.cat")));
		File::Delete(path + FilePath(_T("VirtDiskBus.inf")));
		File::Delete(path + FilePath(_T("VirtDiskBus.cat")));
		return 0;
	}
	if (MessageBox(0, _T("Do you really want to uninstall WinCDEmu?"), _T("Question"), MB_ICONQUESTION | MB_YESNO) != IDYES)
		return 0;
	RemoveDiskEnumerator(_T("root\\BazisVirtualCDBus"));
	RemoveDiskEnumerator(_T("root\\bzsvdisk"));
	RemoveRegistryKeys();
	DeleteFiles();
	MessageBox(0, _T("WinCDEmu was successfully uninstalled."), _T("Information"), MB_ICONINFORMATION);
	return 0;
}
