#pragma once

#include "resource.h"
#include "RegistryParams.h"

class CLetterSelectionDialog : public CDialogImpl<CLetterSelectionDialog>
{
private:
	CComboBox m_cbLetters;
	char m_DriveLetter;
	
	RegistryParams m_RegParams;
	bool m_bForciblyInvoked;

private:
	void DisplayParams();

public:
	CLetterSelectionDialog(bool ForciblyInvoked)
		: m_DriveLetter(0)
		, m_bForciblyInvoked(ForciblyInvoked)
	{
	}

public:
	enum { IDD = IDD_SELECTFOLDER };

	BEGIN_MSG_MAP(CPropertiesDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_CLOSE, OnClose)
		COMMAND_ID_HANDLER(IDOK, OnBnClickedOk)
		COMMAND_ID_HANDLER(IDCANCEL, OnBnClickedCancel)
		COMMAND_ID_HANDLER(IDC_SETTINGS, OnBnClickedSettings)
	END_MSG_MAP()

public:
	// Handler prototypes (uncomment arguments if needed):
	//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);
	LRESULT OnClose(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);
	LRESULT OnBnClickedCancel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedOk(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedSettings(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

public:
	char GetDriveLetter()
	{
		return m_DriveLetter;
	}

	bool IsAutorunDisabled()
	{
		return m_RegParams.DisableAutorun;
	}
private:
	void LocalizeLabels();
};
